Package ghidra.util.database.spatial.rect

# Enum Class Rectangle2DDirection

java.lang.Object
java.lang.Enum<Rectangle2DDirection>
ghidra.util.database.spatial.rect.Rectangle2DDirection

All Implemented Interfaces:
  `Serializable`, `Comparable<Rectangle2DDirection>`, `Constable`

public enum Rectangle2DDirection extends Enum<Rectangle2DDirection>
Specifies which element of a query is returned by `AbstractConstraintsTreeSpatialMap.firstEntry()` and the like.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `BOTTOMMOST`
  Start with element having the least y1 value
  `LEFTMOST`
  Start with element having the least x1 value
  `RIGHTMOST`
  Start with element having the greatest x2 value
  `TOPMOST`
  Start with element having the greatest y2 value

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `isReversed()`
  Check if the direction implies the greatest elements come first Implementors may find this useful for querying internal indices properly.
  `static Rectangle2DDirection`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static Rectangle2DDirection[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### LEFTMOST

    public static final Rectangle2DDirection LEFTMOST
    Start with element having the least x1 value

  - ### RIGHTMOST

    public static final Rectangle2DDirection RIGHTMOST
    Start with element having the greatest x2 value

  - ### BOTTOMMOST

    public static final Rectangle2DDirection BOTTOMMOST
    Start with element having the least y1 value

  - ### TOPMOST

    public static final Rectangle2DDirection TOPMOST
    Start with element having the greatest y2 value

- ## Method Details

  - ### values

    public static Rectangle2DDirection[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static Rectangle2DDirection valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### isReversed

    public boolean isReversed()
    Check if the direction implies the greatest elements come first Implementors may find this useful for querying internal indices properly.
    Returns:
      true if reversed